<script lang="ts" setup>
import { useMenuStore } from "@/stores/menu";
import { onMounted, ref } from "vue";
import MenuDialog from "./MenuDialog.vue";
import MenuDelete from "./MenuDelete.vue";
import type Menu from "@/types/Menu";

const menuStore = useMenuStore();
const backendURL = import.meta.env.VITE_BACKEND_URL;
const TextField = ref(false);
onMounted(async () => {
  await menuStore.getMenus();
});

function showTextField(){
  TextField.value = true;
}

function deletemenu(item: Menu) {
  menuStore.menu = item;
  menuStore.deleteDialog = true;
}

function getMenu(){
    menuStore.getMenus();
}
setInterval(getMenu, 1000);
</script>
<template>
  <MenuDialog></MenuDialog>
  <v-container fluid fill-height class="d-flex justify-center align-center">
    <v-row class="justify-center">
      <v-col>
        <v-card class="ma-5" color="#EEF2E6">
          <v-row class="justify-center">
            <v-card class="pa-5 ma-2 text-h4 text-center" width="100%" color="#1C6758" style="color: white">
              <label style="padding: 10px;">ข้อมูลเมนูอาหาร</label>
              <v-icon color="white" @click="showTextField()">mdi-magnify</v-icon>
              <v-text-field class="input" label="ค้นหาข้อมูลเมนูอาหาร" v-model="menuStore.search" v-if="TextField"  @blur="TextField = false"></v-text-field>
            </v-card>
          </v-row>
          <v-table id="table" style="padding-top: 10px;">
            <thead>
              <tr>
                <th>ID</th>
                <th>Name</th>
                <th>Price</th>
                <th>Type</th>
                <th>Status</th>
                <th>Image</th>
                <th><v-btn size="x-large" class="btng" @click="menuStore.dialog = true">
                    <v-icon>mdi-plus</v-icon>New
                  </v-btn></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item of menuStore.menus" :key="item.id">
                <td>{{ item.id }}</td>
                <td>{{ item.name }}</td>
                <td>{{ item.price }}฿</td>
                <td>{{ item.type }}</td>
                <td class="text-center"><v-switch class="v-input__control" inset v-model="item.status" :label="`${item.status}`" color="success" true-value="on"
                    false-value="off" @click="menuStore.switchMenu(item)" hide-details></v-switch></td>
                <td><v-img height="120" :src="`${backendURL}/menus/image/${item.image}`"></v-img></td>
                <td class="text-center">
                  <span style="padding-right: 10px">
                    <v-btn icon round class="btno" @click="menuStore.editMenu(item)">
                      <v-icon>mdi-pencil</v-icon>
                  </v-btn>
                </span>
                <span style="padding-left: 10px"><v-btn icon round class="btnr" @click="deletemenu(item)">
                    <v-icon>mdi-delete</v-icon>
                  </v-btn>
                </span>
              </td>
            </tr>
          </tbody>
        </v-table>
      </v-card>
    </v-col>
  </v-row>
</v-container>



<!-- <v-btn @click="menuStore.dialog = true">Add New</v-btn>
  <v-table>
    <thead>
      <tr>
        <th>ID</th>
        <th>Name</th>
        <th>Price</th>
        <th>Type</th>
        <th>Status</th>
        <th>Image</th>
        <th>Operations</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="item of menuStore.menus" :key="item.id">
        <td>{{ item.id }}</td>
        <td>{{ item.name }}</td>
        <td>{{ item.price }}</td>
        <td>{{ item.type }}</td>
            <td><v-switch
                  v-model="item.status"
                  :label="`${item.status}`"
                  color="success"
                  true-value="on"
                  false-value="off"
                  @click="menuStore.switchMenu(item)"
                  hide-details
                ></v-switch></td>
            <td><v-img height="120" :src="`${backendURL}/menus/image/${item.image}`"></v-img></td>
            <td>
              <v-btn class="mr-5" @click="menuStore.editMenu(item)"
                >Edit</v-btn
              ><v-btn @click="deletemenu(item)">Delete</v-btn>
            </td>
          </tr>
        </tbody>
      </v-table> -->
  <MenuDelete></MenuDelete>
</template>

<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Noto+Sans+Thai:wght@100&display=swap");


.v-input__control {
  display: flex;
  justify-content: center;
  font-weight: bold !important;
}

label {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 48px !important;
}

.input {
  font-family: "Noto Sans Thai", sans-serif;
}

th {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 24px !important;
  text-align: center;
  font-weight: bold !important;
}

td {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 18px !important;
  font-weight: bold;
  text-align: center;
}

#table {
  border-collapse: collapse;
  width: 100%;
}

#table td,
#table th {
  padding: 10px;
  text-align: center;
}

#table th {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: center;
  background-color: #1c6758;
  color: white;

}

#table tr {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #FFEFCF;
  color: black;
}

.btng {
  background-color: #92D050;
  font-weight: bold !important;
  font-size: 16px !important;
}

.btnr {
  background-color: #FF4A4A;
}

.btno {
  background-color: #FFC000;
}
</style>